package org.etlunit.regular_expression_compiler;

/*
 * Copyright 2001-2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.project.MavenProject;

import java.io.File;

/**
 * @goal generate-regular-expressions
 * @phase generate-sources
 */
public class RegularExpressionCompilerMojo
	extends AbstractMojo {
	/**
	 * @parameter expression="${project}" default-value="${project}"
	 */
	protected MavenProject mavenProject;

	/**
	 * @parameter expression="${outputDirectory}" default-value="${project.build.directory}/generated-sources/regexp"
	 */
	protected File outputDirectory;

	/**
	 * @parameter expression="${regexpSourceDirectory}" default-value="${basedir}/src/main/regexp"
	 */
	protected File regexpSourceDirectory;

	public void execute()
		throws MojoExecutionException {
		outputDirectory.mkdirs();
		regexpSourceDirectory.mkdirs();

		try {
			RegularExpressionProxyClassGenerator.generateProxyFromPropertiesDirectory(regexpSourceDirectory, outputDirectory);
		} catch (Exception e) {
			getLog().error(e);
		}

		mavenProject.addCompileSourceRoot(outputDirectory.getAbsolutePath());
	}
}